﻿function projarc (al,bl,fl,ml)
{
	var a={};
	var b={};
	var f={};
	var g={};
	var h={};

	a=calcsph(al.lati,al.longi);
	b=calcsph(bl.lati,bl.longi);
	f=calcsph(fl.lati,fl.longi);
	
	a=sphcart(a,1);
	b=sphcart(b,1);
	f=sphcart(f,1);

	c=pv (a,b);
	g=pv (c,f);
	h=pv (c,g);
	var nh=norme(h);

	h.x=h.x/nh;
	h.y=h.y/nh;
	h.z=h.z/nh;
	
	//echo ("coordonnées cartésiennes de A ="+Math.round(a.x*10000)/10000+","+Math.round(a.y*10000)/10000+","+Math.round(a.z*10000)/10000);
	//echo ("norme de A="+Math.round(norme(a)*10000)/10000);

	h=cartsph(h,1);
	
	var latitude=90-(h.phi*180/Math.PI);
	var longitude=-(h.theta*180/Math.PI);

	var hl={};
	hl.lati=latitude;
	hl.longi=longitude;
	
	
	hl.lati=-latitude;
	hl.longi=longitude+180;
	
	if (hl.longi>180)
	{hl.longi=hl.longi-360;}
	if (hl.longi<-180)
	{hl.longi=hl.longi+360;}

	return hl;
}

function pv(a,b)
{
	var c={};
	
	c.x=a.y*b.z - b.y*a.z;
	c.y=a.z*b.x - b.z*a.x;
	c.z=a.x*b.y - b.x*a.y;
	return c;
}

function sphcart (p,r)
{
	var qs={};

	qs.x=r*Math.sin(p.phi)*Math.cos(p.theta);
	qs.y=r*Math.sin(p.phi)*Math.sin(p.theta);
	qs.z=r*Math.cos(p.phi);

	return qs;
}

function cartsph (p,r)
{
	var q={};
	
	q.phi=Math.acos(p.z/r);
	q.theta=Math.acos(p.x/r/Math.sin(q.phi));
	
	return q;
}

function calcsph (laticalc,longicalc)
{
	var q={};
	q.phi=(90-laticalc)*Math.PI/180;
	q.theta=-longicalc/180*Math.PI;
	
	return q;
}

function norme (p)
{
	var n=Math.sqrt(p.x*p.x+p.y*p.y+p.z*p.z);
	return n;
}

function liste_foyers()
{
	var foyersb = foyersbruts.split(',');
	nbfoyers=foyersb.length;
	for (i=0;i<nbfoyers;i++)
	{
		f=foyersb[i];
		//if (i<10) {console.log (f);}
		latf=Math.round(9000-dec364 (f.charAt(0)+f.charAt(1)+f.charAt(2)))/100;
		longf=Math.round(dec364 (f.charAt(3)+f.charAt(4)+f.charAt(5))-18000)/100;
		proff=dec64 (f.charAt(6)+f.charAt(7));
		magf=f.charCodeAt(8)-48;
		//if (i<10) {console.log (latf+" "+longf+" "+proff+" "+magf);}
		foyers[i]=new Array();
		foyers[i][0]=latf;
		foyers[i][1]=longf;
		foyers[i][2]=proff;
		foyers[i][3]=magf;
	}
}

function isPointInPoly(poly, pt){
    for(var c = false, i = -1, l = poly.length, j = l - 1; ++i < l; j = i)
        ((poly[i].y <= pt.y && pt.y < poly[j].y) || (poly[j].y <= pt.y && pt.y < poly[i].y))
        && (pt.x < (poly[j].x - poly[i].x) * (pt.y - poly[i].y) / (poly[j].y - poly[i].y) + poly[i].x)
        && (c = !c);
    return c;
}

function getSpPoint(A,B,C){
    var x1=A.x, y1=A.y, x2=B.x, y2=B.y, x3=C.x, y3=C.y;
    var px = x2-x1, py = y2-y1, dAB = px*px + py*py;
    var u = ((x3 - x1) * px + (y3 - y1) * py) / dAB;
    var x = x1 + u * px, y = y1 + u * py;
    return {x:x, y:y}; //this is D
}

function sqr(x) { return x * x }
function dist2(v, w) { return sqr(v.x - w.x) + sqr(v.y - w.y) }
function distToSegmentSquared(p, v, w) {
  var l2 = dist2(v, w);
  if (l2 == 0) return dist2(p, v);
  var t = ((p.x - v.x) * (w.x - v.x) + (p.y - v.y) * (w.y - v.y)) / l2;
  if (t < 0) return dist2(p, v);
  if (t > 1) return dist2(p, w);
  return dist2(p, { x: v.x + t * (w.x - v.x),
                    y: v.y + t * (w.y - v.y) });
}
function distToSegment(p, v, w) { return Math.sqrt(distToSegmentSquared(p, v, w)); }

function extraitfoyers(latmin,longmin,latmax,longmax,latminmt,longminmt,latmaxmt,longmaxmt,d)
{
	//console.log ("entre "+longmin+" et "+longmax);
	var points = [
		{x: longmin, y: latmin},
		{x: longmax, y: latmax},
		{x: longmaxmt, y: latmaxmt},
		{x: longminmt, y: latminmt}
	];
	var tf=new Array;
	var nf=0;
	var dsegment=0;
	
	var p={}; // seisme
	
	var pointa={};
		pointa.x=longmin;
		pointa.y=latmin;
	var pointb={};
		pointb.x=longmax;
		pointb.y=latmax;
	
	
	for (i=0;i<nbfoyers;i++)
	{
		tf[nf]=new Array;
		latf=foyers[i][0];
		longf=foyers[i][1];
		//if (longf<0)
		//{longf=360+longf;}
		if ((longmax>360)||(longmaxmt>360)||(longmin>360)||(longminmt>360)||(longf<0))
		{longf=360+longf;}
		p.x=longf;
		p.y=latf;
		
		if (isPointInPoly(points,p))
		{
				dsegment=distToSegment (p,pointa,pointb);
				if (dsegment<d)
				{
					tf[nf]=foyers[i];
					nf++;
				}
		}
	}
	return tf;
}	


function extraitfoyers2(lat1,long1,lat2,long2,dmax)
{
	var tf=new Array;
	var nf=0;
	
	var p={}; // seisme
	var v={}; // début coupe
	var w={}; // fin coupe
	if (long1<0)
	{long1=360+long1;}
	if (long2<0)
	{long2=360+long2;}
	v.x=long1;
	v.y=lat1;
	w.x=long2;
	w.y=lat2;
	console.log ('extraction des foyers compris entre');
	console.log (lat1+"°N "+long1+"°E et "+lat2+"°N "+long2+"°E");
	
	for (i=0;i<nbfoyers;i++)
	{
		tf[nf]=new Array;
		latf=foyers[i][0];
		longf=foyers[i][1];
		if (longf<0)
		{longf=360+longf;}

		p.x=longf;
		p.y=latf;
		
		d=distToSegment (p,v,w);
		if (d<dmax)
		{
			tf[nf]=foyers[i];
			nf++;
		}
	}
	return tf;
}	
