﻿//http://trac.osgeo.org/openlayers/wiki/GreatCircleAlgorithms  
function dgrand_cercle(a,b)
{
	var latmin=a.lati;
	var latmax=b.lati;
	var longmin=a.longi;
	var longmax=b.longi;
	var d=0;

	var deltalong=Math.abs((longmax%360)-(longmin%360));
	//console.log ("deltalong"+deltalong);
	
	argt=Math.sin(latmin/180*Math.PI)*Math.sin(latmax/180*Math.PI) + Math.cos (latmin/180*Math.PI)*Math.cos (latmax/180*Math.PI)*Math.cos (Math.abs(deltalong/180*Math.PI));
	d=Math.acos(argt)*rterre;
	return d;
}

function cap (pta,ptb)
{
	// we assume that coordinates are Latitude and Longitude as signed decimal degrees with negative longitude in the western hemisphere and negative latitude in the southern hemisphere. 
	// le cap est donné en degrés vers le Nord
	x1=pta.longi; x2=ptb.longi; y1=pta.lati; y2=ptb.lati;
	if (x1>180)
	{
	  x1=x1-360;
	}
	if (x2>180)
	{
	  x2=x2-360;
	}
	//console.log ('calcul du cap pour longmin='+x1+' latmin='+y1+' longmax='+x2+' latmax='+y2);
	x1=x1/180*Math.PI;
	x2=x2/180*Math.PI;
	y1=y1/180*Math.PI;
	y2=y2/180*Math.PI;
	// tout est converti en radian
	aa=Math.cos(y2)*Math.sin(x2-x1);
	bb=Math.cos(y1)*Math.sin(y2) - Math.sin(y1)*Math.cos(y2)*Math.cos (x2-x1);
	adjust=0;
	if((aa == 0) && (bb == 0)) 
	{
		  bearing = 0;
	}
	else if( bb == 0) 
	{
		  if( aa < 0)  
			  bearing = 3 * Math.PI / 2;
		  else
			  bearing = Math.PI / 2;
	} 
	else if( bb < 0) 
		  adjust = Math.PI;
	else
	{
		  if( aa < 0) 
			  adjust = 2 * Math.PI;
		  else
			  adjust = 0;
	}
	return (Math.atan(aa/bb) + adjust);
	
  
} 

function wp(ptc,cap,d)
{
	var pwp={};
	x1=ptc.longi/180*Math.PI;
	y1=ptc.lati/180*Math.PI;
	// tout est converti en radian
	d=d/6400;
	y2 = Math.asin( Math.sin(y1) * Math.cos(d) + Math.cos(y1) * Math.sin(d) * Math.cos(cap));
	a = Math.sin(d) * Math.sin(cap);
	b = Math.cos(y1) * Math.cos(d) - Math.sin(y1) * Math.sin(d) * Math.cos(cap);

	if( b == 0 ) 
      x2 = x1;
	else
      x2 = x1 + Math.atan(a/b);
	  
	t=new Array();
	
	pwp.longi=x2*180/Math.PI;
	pwp.lati=y2*180/Math.PI;
	return pwp;
	// attention valeurs des longitudes et latitudes en radians

}

