function getcoul (x,y)
{
	if (douxc)
	{
		rx=(x%1);
		ix=Math.floor(x);
		rrx=1-rx;
		ry=(y%1);
		rry=1-ry;
		iy=Math.floor(y);
		
		nc1a=coulc.data[ix*4   +iy*21600];
		nc2a=coulc.data[ix*4+1 +iy*21600];
		nc3a=coulc.data[ix*4+2 +iy*21600];
		
		nc1b=coulc.data[(ix+1)*4   +iy*21600];
		nc2b=coulc.data[(ix+1)*4+1 +iy*21600];
		nc3b=coulc.data[(ix+1)*4+2 +iy*21600];

		nc1c=coulc.data[ix*4       +(iy+1)*21600];
		nc2c=coulc.data[ix*4+1     +(iy+1)*21600];
		nc3c=coulc.data[ix*4+2     +(iy+1)*21600];
		
		nc1d=coulc.data[(ix+1)*4   +(iy+1)*21600];
		nc2d=coulc.data[(ix+1)*4+1 +(iy+1)*21600];
		nc3d=coulc.data[(ix+1)*4+2 +(iy+1)*21600];
		
		nc1=nc1a*rrx*rry +nc1b*rx*rry +nc1c*ry*rrx +nc1d*ry*rx;
		nc1=nc1/(rrx*ry +rx*ry +rrx*rry +rx*rry);
		nc2=nc2a*rrx*rry +nc2b*rx*rry +nc2c*ry*rrx +nc2d*ry*rx;
		nc2=nc2/(rrx*ry +rx*ry +rrx*rry +rx*rry);
		nc3=nc3a*rrx*rry +nc3b*rx*rry +nc3c*ry*rrx +nc3d*ry*rx;
		nc3=nc3/(rrx*ry +rx*ry +rrx*rry +rx*rry);
		
		var tc=new Array ();
		tc[0]=Math.round(nc1);
		tc[1]=Math.round(nc2);
		tc[2]=Math.round(nc3);
		return tc;
	}
	else
	{
		ix=Math.round(x);
		iy=Math.round(y);
				
		nc1=coulc.data[ix*4+iy*21600];
		nc2=coulc.data[ix*4+1+iy*21600];
		nc3=coulc.data[ix*4+2+iy*21600];
		var tc=new Array ();
		tc[0]=nc1;
		tc[1]=nc2;
		tc[2]=nc3;
		return tc;
	}
}



function valanom(longanom,latanom,profanom)
{
	if (longanom<0)
	{
	  longanom=longanom+360;
	}
	//calcul du rang au sein de la tranche de profondeur
	num=Math.round(longanom/360*576)+Math.round(latanom/180*288)*576;
	if ((num<0)||(num>165163)||(profanom>29)||(profanom<1))
	{
		return 2048;
		
	}
	num=num*2;
	v=dec64(valeurs[profanom][num]+valeurs[profanom][num+1]);
	return v;
	
}

function profmoho(longmoho,latmoho)
{
	longmoho=longmoho+180;
	if (longmoho>360)
	{
	  longmoho=longmoho-360;
	}
	if (longmoho<0)
	{
	  longmoho=longmoho+360;
	}
	latmoho=90-latmoho;
	//console.log (longmoho);
	//console.log (latmoho);
	//calcul du rang au sein de la tranche de profondeur
	num=Math.round(longmoho*2);
	ligne=Math.round(latmoho*2);
	if ((num<0)||(num>719)||(ligne<0)||(ligne>359))
	{
		return 8; //profondeur moyenne du moho ocanique par dfaut
	
	}
	num=num*2;
	//console.log ("ligne="+ligne);
	//console.log ("num="+num);
	//console.log (valmoho[ligne][num]+valmoho[ligne][num+1]);
	v=dec64(valmoho[ligne][num]+valmoho[ligne][num+1]);
	maxi=105.2;
	mini=4.8;
	ecart=100.4;
	v=v/4096*ecart;
	v=v+mini;
	return v;
	
}

function altitude_smooth (x,y)
{
	if (doux)
	{
		rx=(x%1);
		ix=Math.floor(x);
		rrx=1-rx;
		ry=(y%1);
		rry=1-ry;
		iy=Math.floor(y);
		va=altitude (ix,iy);
		vb=altitude (ix+1,iy);
		vc=altitude (ix,iy+1);
		vd=altitude (ix+1,iy+1);
		v=va*rrx*rry +vb*rx*rry +vc*ry*rrx +vd*ry*rx;
		v=v/(rrx*ry +rx*ry +rrx*rry +rx*rry);
		
		return v;
	}
	else
	{
		v=altitude (Math.round(x),Math.round(y));
		return v;
	}
}

function altitude(xh,yh)
{
		h=ele.data[xh*4+yh*21600]-12;
		h=h*32;
		bb=256-bath.data[xh*4+yh*21600];
		//128 correspond  5000m environ
		b=bb*10000/256;
		//console.log (h+" "+b);
		if ((h<=0)&&(batok==true))
		{
			h=h-b;
		}
		return h;
}