function calcul_couvercle()
{

		var tabh2=new Array();
		var tabcoul2=new Array();
		minh=0;
		for (j=0;j<=50*qualy;j++)
		{
				tabh2[j]=new Array();
				tabh[j]=new Array();
				tabcoul[j]=new Array();
				tabcoul2[j]=new Array();
				for (i=0;i<=500;i++)
				{
					xh=xc[i]+pasx*j*2/qualy;
					yh=yc[i]+pasy*j*2/qualy;
										
					h=altitude_smooth(xh,yh)/1000; // en km
					
					if ((j==0)&&(h<minh))
					{ minh=h; } 
					
					tabh2[j][i]=h; 
																		
					tabcoul[j][i]=new Array();
					tabcoul[j][i]=getcoul (xh,yh);

				}// next i
		}//next j
		tabh=tabh2;
		tabcoul2=tabcoul;

		//console.log ('altitude min='+minh);
	
}

function prepare_couvercle()
{
		//effacement
		ctxtomo.clearRect ( x0tomo , 0 , 600 , y0tomo-50);
		ctxtomo.fillStyle="rgb(255,255,255)";
		ctxtomo.beginPath();
		ctxtomo.moveTo(0,y0tomo);
		ctxtomo.lineTo(x0tomo,y0tomo);
		ctxtomo.lineTo(x0tomo+50,y0tomo-50);
		ctxtomo.lineTo(x0tomo+50,0);
		ctxtomo.lineTo(0,0);		
		ctxtomo.lineTo(0,y0tomo-50);
		ctxtomo.lineTo(0,y0tomo);
		ctxtomo.closePath();
		ctxtomo.fill();
				
		//croute
		var x0=1+x0tomo;
		var y0=y0tomo;
		ctxtomo.beginPath();
		ctxtomo.lineWidth=1; 
		ctxtomo.strokeStyle="rgb(200,200,200)";
		//ctxtomo.fillStyle="rgb(100,80,80)";
		ctxtomo.moveTo(x0-0.5,y0+0.5);
		ctxtomo.lineTo(x0-0.5,htotale+0.5);
		ctxtomo.lineTo(x0+0.5+500,htotale+0.5);
		ctxtomo.moveTo(x0+0.5,y0+0.5);
		ctxtomo.lineTo(x0+0.5+50,y0-50+0.5);
		ctxtomo.lineTo(x0+500+50,y0-50+0.5);
		ctxtomo.lineTo(x0+500,y0+0.5);
		ctxtomo.moveTo(x0+500+50,y0-50+0.5);
		ctxtomo.lineTo(x0+500+50,htotale-50+0.5);
		ctxtomo.stroke();
}

function couvercle_rapide()
{
		// car sinon impossible de modifier pixels
		ctxtomo.beginPath();
		ctxtomo.moveTo(x0tomo,y0tomo);
		ctxtomo.lineTo(x0tomo+50,y0tomo-50);
		ctxtomo.lineTo(x0tomo+550,y0tomo-50);
		ctxtomo.lineTo(x0tomo+500,y0tomo);
		ctxtomo.closePath();
		ctxtomo.fillStyle='black';
		ctxtomo.fill();

		// on rcupre le rectangle
		var imgDataPrisR=ctxtomo.getImageData(x0tomo,0,550,y0tomo);
		

		var xi=0;
		var yi=0;
		var jj=0;
		for (var i=0;i<500;i++)
			for (var j=50;j>0;j--)
			{
				jj=j*qualy;
				xi=i+j;
				yi=y0tomo-j;
				imgDataPrisR.data[xi*4+yi*550*4]=tabcoul[jj][i][0];
				imgDataPrisR.data[xi*4+yi*550*4+1]=tabcoul[jj][i][1];
				imgDataPrisR.data[xi*4+yi*550*4+2]=tabcoul[jj][i][2];
			
			}

		ctxtomo.putImageData(imgDataPrisR,x0tomo,0);
}


function couvercle()
{
		// car sinon impossible de modifier pixels
		ctxtomo.beginPath();
		ctxtomo.moveTo(x0tomo,y0tomo);
		ctxtomo.lineTo(x0tomo+50,y0tomo-50);
		ctxtomo.lineTo(x0tomo+550,y0tomo-50);
		ctxtomo.lineTo(x0tomo+500,y0tomo);
		ctxtomo.closePath();
		ctxtomo.fillStyle='black';
		ctxtomo.fill();
		
		// mise  jour du facteur d'exagration
		dimrel=exag/(profmax-profmin)*(htotale-y0tomo);
		
		var x0=1+x0tomo;
		decalrelief=Math.round((exag-1)*dimrel/10);
		var y0=y0tomo-decalrelief;
		hhmax=100;
		var jj=50*qualy;
			var dessine=function ()
			{
				if (jj==0)
				{
					tranche_grise();
				}
				else
				{
					for (var ii=0;ii<500;ii++)
					{
						h=tabh[jj][ii]-minh;
						
						hi=Math.round(h*dimrel)+1;
						//if (i==0) {console.log(hi);}
											
						if (hi>hhmax) {hi=hhmax;}

						couleur="rgb("+tabcoul[jj][ii][0]+","+tabcoul[jj][ii][1]+","+tabcoul[jj][ii][2]+")";						
						ctxtomo.fillStyle=couleur;
						x2=x0+ii+jj/qualy;
						y2=y0-jj/qualy-hi;

						ctxtomo.fillRect(x0+ii+jj/qualy,y2,1,hi);
						
					} // next i
				}// jj>0
				jj--;
				if (jj>=0)
				{
					if ((jj%110)==0)
					{
						setTimeout (dessine, 1);
					}
					else
					{
						dessine();
					}
				}
			}
			
			dessine();
			//if (j >0) 
			//{ 
			//	if ((j%500)==0) // pour l'instant je dbraye le timeout
			//	{ 
			//		setTimeout(drawPortion, 1); 
			//	}
			//	else
			//	{
			//	    drawPortion();
			//	}
			//}
			//if (j >0) { drawPortion()}
		
		
		//setTimeout(drawPortion, 1); 
		//setTimeout(tranche_grise, 1); 
		

}

function tranche_grise()
{
	var a=0;
	var h=0;
	var hi=0;
	var x1=0;
	var x2=0;
	// mise  jour du facteur d'exagration
	dimrel=exag/(profmax-profmin)*(htotale-y0tomo);
	
	decalrelief=Math.round((exag-1)*dimrel/10);

	
	var x0=1+x0tomo;
	var y0=y0tomo-decalrelief;
	
	// aplat gris sur la tranche frontale
	ctxtomo.fillStyle="rgb(100,80,80)";
	for (var i=0;i<500;i++)
	{
		h=tabh[0][i]-minh;
		hi=Math.round(h*dimrel);
		if (hi>hhmax) {hi=hhmax;}
		ctxtomo.fillRect(x0+i,y0-hi,1,hi+decalrelief);
	}
	ctxtomo.fillStyle = "black";
	x1=x0tomo+20;
	x2=x0tomo+488;
	y1=y0tomo-5;
	y2=y0tomo-65;
	for (i=-1;i<2;i++)
	  for (var j=-1;j<2;j++)
	  {
		ctxtomo.font = "16px Arial";
		ctxtomo.fillText("A",x1+i,y1-j);
		ctxtomo.fillText("B",x2+i,y1-j);
		}
	ctxtomo.font = "16px Arial";
	ctxtomo.fillStyle = "white";
	ctxtomo.fillText("A",x1,y1);
	ctxtomo.fillText("B",x2,y1);
	if (idrapeau>0)
	{
		x=idrapeau+x0tomo+0.5;
		a=tabh[0][idrapeau];
		h=a-minh;
		hi=Math.round(h*dimrel);
		if (hi>hhmax) {hi=hhmax;}
		
		ctxtomo.strokeStyle="white";
		ctxtomo.beginPath();
		ctxtomo.moveTo (x,y0-hi);
		ctxtomo.lineTo (x,y0-hi-15);
		ctxtomo.stroke();
		ctxtomo.strokeStyle="black";
		ctxtomo.beginPath();
		ctxtomo.moveTo (x+1,y0-hi);
		ctxtomo.lineTo (x+1,y0-hi-15);
		ctxtomo.stroke();
		ctxtomo.font = "12px Verdana";
		ctxtomo.textAlign="center";
		ctxtomo.fillStyle="black";
		for (i=-1;i<2;i++){
		for (j=-1;j<2;j++){
			ctxtomo.fillText (Math.round(a*10)/10+" km",x+i,y0-hi-20+j);
		}}
		
		ctxtomo.fillStyle="white";
		ctxtomo.fillText (Math.round(a*10)/10+" km",x,y0-hi-20);
		
	}
	
	// aplat gris sur le ct
	ctxtomo.fillStyle="rgb(100,80,80)";
	for (j=0;j<50;j++)
	{
					
		h=tabh[j*qualy][500]-minh;
		hi=Math.round(h*dimrel);
	
		if (hi>hhmax) {hi=hhmax;}
		ctxtomo.fillRect(x0+500+j,y0-hi-j,1,hi+decalrelief);
	}


}

