﻿function thq(q)
{
	if (q)
	{
		doux=true;
		douxc=false;
		qualy=4;
	}
	else
	{
		doux=false;
		douxc=false;
		qualy=1;
	}
}

function affiche_consignes()
{
	ctxtomo.clearRect ( 0 , 0 , 700 , 400 );
	ctxtomo.font = "20px Arial";
	ctxtomo.textAlign = "left";
	ctxtomo.fillStyle = "black";
	ctxtomo.fillText("TOMOGRAPHIE SISMIQUE",45,30);
	ctxtomo.fillText("Délimiter le plan de coupe en cliquant sur deux points",45,70);
	ctxtomo.fillText("de la carte.",45,100);
	ctxtomo.fillText("Cliquer/glisser pour déplacer la carte.",45,140);
	ctxtomo.fillText("Double-cliquer sur la carte pour zoomer/dézoomer.",45,180);
	ctxtomo.fillText("Cliquer sur la tomographie pour obtenir des informations",45,220);
	ctxtomo.fillText("Touche Echap pour réinitialiser.",45,260);
}

function etape_suivante()
{
	etape++;
	ctxtomo.clearRect ( 15 , 0 , 670 , 75 );
	ctxtomo.fillText("Veuillez patienter (étape "+etape+"/51)",20,25);
	ctxtomo.fillStyle = "black";
	ctxtomo.strokeStyle='black';
	ctxtomo.lineWidth=1; 	
	ctxtomo.beginPath();
	ctxtomo.rect (20,40,660,30);
	ctxtomo.stroke();
	ctxtomo.fillRect (25,45,etape*650/51,20);
	if (etape>51)
	{
		init();
	}
}



function affiche_carte ()
{
  if (initialise==1)
  {
	console.log ('affichage des cartes');
	contextcarte.clearRect ( 0 , 0 , 700 , 350 );
	canvascarte.backgroundImageStretch = false;	
	

	// image basse résolution
	imglr = document.getElementById('imagecarte700');
	contextcarte.drawImage(imglr, 0, 0 );
		
	if (ele.data[0]!=12)
	{
		console.log ("Erreur avec les données d'élévation, la page va se recharger ...");
		window.location.reload();		
	}

	document.getElementById("divcarte").style.visibility="visible";
	affiche_consignes();
	rafraichit_carte();
  }
  
}



function clavier (ev){
	touche=((ev.which)||(ev.keyCode));

	if (touche==27)
	{
		coupespherique=false;
		document.getElementById('checkboxsph').checked =false;
		document.getElementById("divcoupesph").style.visibility="hidden";
		document.getElementById("divcoupesph2").style.visibility="hidden";
		change_coupe();
		efface_tomo();
		vmoy=2048;
		clic=-1;
		deplace=0;
		xcroix[0]=xcroix[1];
		ycroix[0]=ycroix[1];
		if (zoomv==1)
		{
			zoom(0,0);
		}
		rafraichit_carte();
		return false;
	}
	
	if (touche==65)
	{
		affiche_tomocarte();
	}
	
}

function init ()
{
	document.body.addEventListener("keydown", clavier, false);
	liste_foyers();
	
	document.getElementById("divopa").style.visibility="hidden";
	document.getElementById("a5").style.visibility="hidden";
	
	document.getElementById("divtomocarte").style.visibility="hidden";
	document.getElementById("divtomocarte2").style.visibility="hidden";
		
	ctxtomo.font = "12px Arial";
	ctxtomo.clearRect ( 15 , 55 , 670 , 50 );
	ctxtomo.fillText("Initialisation",20,80);
	
	initialise=1;
	console.log('initialisation');
	
	change_coupe();
	affiche_carte();
		
}

function affiche_charge (texte)
{
	ctxtomo.font = "12px Arial";
	ctxtomo.clearRect ( 15 , 90 , 670 , 30 );
	ctxtomo.fillText(texte,20,100);
}

function affiche_charge2 (texte,y)
{
	ctxtomo.font = "12px Arial";
	ctxtomo.clearRect ( 15 , 120+y*20 , 670 , 20 );
	ctxtomo.fillText(texte,20,130+y*20);
}

function charge(nomf)
{
	affiche_charge ("Chargement du script "+nomf);
	var fileref=document.createElement('script');
	fileref.setAttribute("type","text/javascript");
	//fileref.async = true;
	fileref.setAttribute("src", "scripts/"+nomf+".js");
	var js=document.getElementsByTagName("head")[0].appendChild(fileref);
    js.onload = function () {
		//console.log (nomf+" chargé.");
		etape_suivante();
	}


}

function charge_valeur (nv)
{
	var fileref=document.createElement('script');
	fileref.setAttribute("type","text/javascript");
	fileref.setAttribute("src", "valeurs/"+nv+".js");
	affiche_charge ("Chargement de la tranche de valeurs n°"+nv);
	var js=document.getElementsByTagName("head")[0].appendChild(fileref);
	js.onload = function () {
			etape_suivante();		
			if (nv<29)
			{
			  nv++;
			  charge_valeur (nv);
			}
			
	}
	
}

function demarre2() {
	etape_suivante();
	charge ('elevation5400test');
	charge ('bathytest');
	charge ('carte5400test');
	charge ('extrait_foyers');
	charge ('valfoyers');
	charge ('valanom');
	charge ('rafraichit_carte');
	charge ('grand_cercle');
	charge ('valmoho');
	charge ('encdec64');
	charge ('calcul');
	charge ('clic_carte');
	charge ('clic_tomo');
	charge ('tomocarte');
	charge ('couvercle');
	charge ('coupe_hori');
	charge ('coupe_sphere');
	charge ('clic_coupe_sphere');
	
	charge_valeur (0);

}
